
/**
 *
 * \file     km_dsfmt_jump.h
 * \brief    interface between dSFMT-jump and external codes (C,C++,FORTRAN)
 * \authoers Toshiyuki Imamura (TI)
 * \date     2014/03/09 (NT)
 * 
 * (c) Copyright 2013 RIKEN. All rights reserved.
 */

#ifndef __km_dsfmt_jump_h__
#define __km_dsfmt_jump_h__

#include "dSFMT.h"

#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif

  /**
   *
   * Function    km_dsfmt_jump_do_
   * \brief      jump dSFMT random number using rank informations
   * \authors    NT
   * \param[out] dsfmt     structure of dSFMT
   * \param[in]  seed      random seed number
   * \param[in]  irank     rank number
   * \param[in]  nrank     number of ranks
   * \param[out] ret       error information (0: no error)
   * \date       2013/12/10 (NT)
   *
   */
  extern void km_dsfmt_jump_do_(dsfmt_t* dsfmt, 
				const int* seed,
				const int* irank,
				const int* nrank,
				int* ret);
  
#if defined(__cplusplus) || defined(c_plusplus)
}
#endif

#endif // !__km_dsfmt_jump_h__
