
/**
 *
 * \file     km_dsfmt_jump.h
 * \brief    interface functions of dSFMT-jump
 * \authoers Toshiyuki Imamura (TI)
 * \date     2014/03/09 (NT)
 * 
 * (c) Copyright 2013 RIKEN. All rights reserved.
 */

#ifndef __km_dsfmt_jump_h__
#define __km_dsfmt_jump_h__

#include "dSFMT.h"

#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif

  /**
   *
   * Function    km_dsfmt_jump_gen_init_
   * \brief      initialize for generation of dSFMT jump file
   * \authors    NT
   * \param[in]  max_ranks     maximum number of ranks
   * \param[in]  rand_range    random number range per rank
   * \param[in]  install_dir   install directory
   * \param[in]  file_prefix   jump file prefix
   * \date       2013/12/09 (NT)
   *
   */
  extern void km_dsfmt_jump_gen_init_(const int*  max_ranks,
				      const int*  rand_range,
				      const char* install_dir,
				      const char* file_prefix);

  /**
   *
   * Function    km_dsfmt_jump_gen_
   * \brief      generate dSFMT jump file
   * \authors    NT
   * \param[in]  seed        random seed number
   * \date       2013/12/09 (NT)
   *
   */
  extern void km_dsfmt_jump_gen_(const int* seed, int* ret);

  
#if defined(__cplusplus) || defined(c_plusplus)
}
#endif

#endif // !__km_dsfmt_jump_h__
