
/**
 *
 * \file     km_rand_chk_jump.c
 * \brief    check dSFMT jump file
 * \authoers Toshiyuki Imamura (TI)
 * \date     2013/12/10 (NT)
 * 
 * (c) Copyright 2013 RIKEN. All rights reserved.
 */


#include <stdio.h>
#include "dSFMT.h"


int main(int argc, char** argv)
{
  if (argc < 2)
    {
      printf("USAGE: %s <check-filename>\n", argv[0]);
      return -1;
    }

  FILE* fp = fopen(argv[1], "r");
  if (fp == NULL)
    {
      printf("ERROR : can not open file.\n");
      return -1;
    }
    
  int max_ranks;
  if (fread(&max_ranks, sizeof(int), 1, fp) != 1)
    {
      printf("ERROR : can not read maximum number of ranks\n");
      fclose(fp);
      return -1;
    }
  printf("maximum number of ranks = %d\n", max_ranks);
  

  for(int i = 0; i < max_ranks; ++i)
    {
      dsfmt_t dsfmt;

      if (fread(&dsfmt, sizeof(dsfmt_t), 1, fp) != 1)
	{
	  printf("ERROR : can not read structure dsfmt_t\n");
	  fclose(fp);
	  return -1;
	}

      printf("Rank:%d  random : %f\n",
	     i, dsfmt_genrand_close1_open2(&dsfmt));
    }


  fclose(fp);

  return 0;
}
