
/**
 *
 * \file     test_c_vec.c
 * \brief    test of KMATH random C module
 * \authoers Toshiyuki Imamura (TI)
 * \date     2013/02/04 (NT)
 * \date     2013/12/17 (NT)
 * 
 * (c) Copyright 2013 RIKEN. All rights reserved.
 */

#include "kmath_random.h"
#include <stdio.h>

int main(int argc, char** argv)
{
  int comm_rank, i;
  void* h;

  MPI_Init(&argc, &argv);
  MPI_Comm_rank(MPI_COMM_WORLD, &comm_rank);

  h = KMATH_Random_init(MPI_COMM_WORLD);
  if (h == NULL)
    {
      printf("Failed to initialize. rank:%d\n", comm_rank);
      MPI_Finalize();
      return -1;
    }

  char file[128];
  sprintf(file, "out_c_vec_rnk%04d", comm_rank);
  FILE* fp = fopen(file,"w");

  KMATH_Random_seed(h, 1);

  double va[5000];
  KMATH_Random_vector(h, va, 4156); /* 4156 = ((216091-128)/104+1)*2 */

  for(i = 0; i < 10; ++i)
    {
      fprintf(fp, " %17.15f\n", va[i]);
    }

  fclose(fp);

  KMATH_Random_finalize(h);

  MPI_Finalize();
  return 0;
}
