
/**
 *
 * \file     test_cpp_vec.cpp
 * \brief    test of KMATH random C++ module
 * \authoers Toshiyuki Imamura (TI)
 * \date     2013/02/06 (NT)
 * \date     2013/12/17 (NT)
 * 
 * (c) Copyright 2013 RIKEN. All rights reserved.
 */

#include "kmath_random.h"
#include <stdio.h>

int main(int argc, char** argv)
{
  KMATH_Random rand;
  int comm_rank;

  MPI_Init(&argc, &argv);
  MPI_Comm_rank(MPI_COMM_WORLD, &comm_rank);

  if (!rand.init(MPI_COMM_WORLD))
    {
      printf("Failed to initialize.\n");
      return -1;
    }

  char file[128];
  sprintf(file, "out_cpp_vec_rnk%04d", comm_rank);
  FILE* fp = fopen(file,"w");

  rand.seed(1);

  double va[5000];
  rand.get(va, 4156); // 4156 = ((216091-128)/104+1)*2

  for(int i = 0; i < 10; ++i)
    {
      fprintf(fp, " %17.15f\n", va[i]);
    }

  fclose(fp);

  rand.finalize();

  MPI_Finalize();

  return 0;
}
