
!--------1---------2---------3---------4---------5---------6---------7---------8
!
!  Program  test_f90_seq
!> @brief   test of KMATH random FORTRAN90 module
!! @authors Toshiyuki Imamura (TI)
!! @date    2013/02/04 (NT)
!! @date    2013/12/17 (NT)
!
!  (c) Copyright 2013 RIKEN. All rights reserved.
!
!--------1---------2---------3---------4---------5---------6---------7---------8
program test_f90_seq

  use kmath_random_mod
  use mpi

  implicit none


  ! local variables
  type(s_km_rand)  :: rand
  double precision :: v
  integer          :: comm_rank, ierr, i
  character(256)   :: file


  call MPI_Init(ierr)
  call MPI_Comm_rank(MPI_COMM_WORLD, comm_rank, ierr)

  call KMATH_Random_Init(rand, MPI_COMM_WORLD, ierr)
  if (ierr /= 0) then
    write(6,*) 'Failed to initialize. rank:', comm_rank
    call MPI_Finalize(ierr)
    stop
  end if

  write(file,'(a,i4.4)') 'out_f90_seq_rnk', comm_rank
  open(11,file=file,status='new',form='formatted')

  call KMATH_Random_Seed(rand, 1, ierr);

  do i = 1, 10
    call KMATH_Random_Get(rand, v, ierr)
    write(11,*) v
  end do

  close(11)

  call KMATH_Random_Finalize(rand, ierr)

  call MPI_Finalize(ierr)
  stop

end program test_f90_seq
