
#include <NTL/GF2X.h>
#include <NTL/ZZ.h>
#include <iostream>
#include <fstream>

#define DSFMT_MEXP 19937

#include "dSFMT.h"
#include "dSFMT-calc-jump.hpp"
#include "dSFMT-jump.h"

using namespace NTL;
using namespace std;
using namespace dsfmt;

void _calc_jump(string& jump_str, int rand_range)
{
  string line;
  ifstream ifs("./poly.19937.txt");
  if (ifs)
    {
      ifs >> line;
      line = "";
      ifs >> line;
    }

  ZZ range;
  range = 1;
  for(int i = 0; i < rand_range; ++i)
    range *= 2;

  GF2X poly;
  stringtopoly(poly, line);

  calc_jump(jump_str, range, poly);
}

int main(int argc, char** argv)
{
  if (argc <= 3)
    {
      printf("Usage %s <seed> <range> <nproc>\n", argv[0]);
      return -1;
    }

  int seed  = atoi(argv[1]);
  int range = atoi(argv[2]);
  int nproc = atoi(argv[3]);

  string jump_str;
  _calc_jump(jump_str, range);

  dsfmt_t dsfmt;

  for (int i = 0; i < nproc; ++i)
    {
      dsfmt_init_gen_rand(&dsfmt, seed);

      for (int k = 0; k < i; ++k)
	dSFMT_jump(&dsfmt, jump_str.c_str());

      for (int j = 0; j < 10; ++j)
	{
	  double val = dsfmt_genrand_close1_open2(&dsfmt);
	  printf("%f\n", val);
	}
    }

  return 0;
}
